# Usage: perl createB.pl -method Base -cohort 1 -target 0 -coverp 10 -clength 5 -noisep 0 -lcount 50 -fold f
#amended hastly to generate folds

use strict;
use warnings;
use Carp;

my @targets=('N', 'S'); 
my @cohorts=('O', 'Y');

#Process input and create files
my %args = @ARGV;
my $method  = $args{-method} || 
    confess "Input a method as: -method method[DP|Gen]";
my $t =  $args{-target}; 
confess "Input the target as: -target target" if !defined $t;
my $c =  $args{-cohort};
confess "Input the cohort as: -cohort cohort" if !defined $c;
my $coverp =  $args{-coverp} || 
    confess "Input the cover percentage as: -coverp coverp";
my $clauseLength = $args{-clength} || 
    confess "Input the max clause length as: -clength clength";
my $noisep =  $args{-noisep} || 0;
my $lcount = $args{-lcount} ||
    confess "Input the line count: -lcount lcount";
my $fold = $args{-fold} ||
    confess "Input the fold number: -fold fold";

#create aleph parameters
#my $code = "/u/nassif/research/DP/ECML2011/UCSF10/runs/code/";
my $data = "../data/";
my $results = "../results/";
my $output = "instructions.b";
my $input = $method."instructions.b";
my $noise = int($lcount * $noisep / 100);
my $cover = int($lcount * $coverp / 100);
my $fileName = "fold$fold\_$method\_$cohorts[$c]$targets[$t]\_$coverp\_$noisep";

open(INPUT, $input) ||
    confess "couldn't open ", $input, ": $!. Stopped"; 
open(OUTPUT, '>', $output) ||
    confess "couldn't open ", $output, ": $!. Stopped";

#write aleph .b file
while (my $line = <INPUT>){
    $line =~ s/(set\(clauselength,)(\s*\d*)/$1$clauseLength/;
    $line =~ s/(set\((minpos|m),)(\s*\d*)/$1$cover/;
    $line =~ s/(set\((noise),)(\s*\d*)/$1$noise/;

    $line =~ s/(set\(recordfile,\s*)(.*)(\).)/$1'$results$fileName.trace'$3/;
    $line =~ s/(set\(rulefile,\s*)(.*)(\).)/$1'$results$fileName.hyp'$3/;

    $line =~ s/(alt_train_pos:\s*)(.*)(\].)/$1'$data$cohorts[($c+1)%2]$targets[$t]train$fold.fn'$3/;
    $line =~ s/(alt_train_neg:\s*)(.*)(\].)/$1'$data$cohorts[($c+1)%2]$targets[($t+1)%2]train$fold.fn'$3/;

    $line =~ s/(set\(train_pos,\s*)(.*)(\).)/$1'$data$cohorts[$c]$targets[$t]train$fold.fn'$3/;
    $line =~ s/(set\(train_neg,\s*)(.*)(\).)/$1'$data$cohorts[$c]$targets[($t+1)%2]train$fold.fn'$3/;
    $line =~ s/(consult\()(.*)(\).)/$1'${data}DP.bk'$3/;
    

    #if allowing noise or not
    ($noise)?
	($line =~ s/^(\%+)(.*set\(noise)/$2/) :
	($line =~ s/(^.*set\(noise)/\%$1/);

    print OUTPUT $line;
}
