%Generate-then-test specific instructions

%%% Aleph Parameters---------------------------------
:- set(evalfn,user). %Clause utility is -value returned by user-defined cost()
:- set(clauselength,5).
:- set(minpos,10).
:- set(m,10).
:- set(noise,10).
:- set(rulefile,'../results/Gen_OS_10_10.hyp').


%%% Train and Test Sets---------------------------------
:- set(record,true).
:- set(recordfile,'../results/Gen_OS_10_10.trace').
:- set(train_pos, '../data/OS.fn').
:- set(train_neg, '../data/ON.fn').

%load alternate examples in different module, so they don't get mixed up
:- [alt_train_pos:'../data/YS.fn'].
:- [alt_train_neg:'../data/YN.fn'].


%%% Background Knowledge---------------------------------
:- consult('../data/DP.bk').


%%% Alternate Cost Function---------------------------------
%get the clause coverage on alternate pos and neg
apply_rule_on_alternate(Clause, AP, AN) :-
        Clause = (H :- B), %specify clause shape
%       writeln(doing:Clause),get0(_), %get is waiting for a character input
        %get matches list
        findall( H, (alt_train_pos : H, \+ alt_deleted(H), once(B)), List_AP),
        length(List_AP, AP), %get the length of the list
        findall( H, (alt_train_neg : H, once(B)), List_AN),
        length(List_AN, AN).

%%% Cost function
cost(Clause, [P, N, L], Cost) :-
	evalfn(mestimate, [P,N,L], Acc1),
	Cost is -P * Acc1.
